#	This script provides a LOOP around a separate Process File script.
#
#	J J A Pacilly, 16-jan-2001, for Petra Poelmans
#	J J A Pacilly, 27-oct-2004, separate script and data
#	J J A Pacilly, 24-jan-2006, allow white space in data file names,
#	                            die gracefully if no files are found
#	J J A Pacilly, 26-apr-2007, permit optional arguments
#	J J A Pacilly,  5-jun-2007, allow white space in script file names
#	J J A Pacilly, 22-jan-2009, adapt FileSpec to modifications in VUW-2
#
#	Usage: Praatcon Pmf.praat J:\Applications\Praat\Pf.praat "P:\My Documents\Praat Data\*.wav" 1 Two "3 Four"
#
#	NOTE: When started from the Windows Command Prompt, surround wildcards
#	      and empty arguments by double quotes, to prevent Windows from
#	      doing wildcard expansion, and 'borrowing' 'white-space-separated'
#	      parts of earlier arguments on the command line.

form Process Multiple Files
  comment Process Multiple files...
  sentence Script J:\Applications\Praat\Pf.praat
  sentence FileSpec P:\My Documents\Praat Data\*.wav
  sentence Args 1 Two "3 Four"
  endform

len        = length(fileSpec$)
sep        = rindex(fileSpec$, "\")
directory$ =  left$(fileSpec$, sep)
selection$ = right$(fileSpec$, len-sep)

nocheck Create Strings as file list... fileList 'directory$''selection$'
nfiles = Get number of strings

if not numberOfSelected("Strings")

  eMessage$ = "'directory$''selection$''newline$'Files(s) not found.'newline$'
...Please verify that the correct directory path and file name(s) are given."
  exit 'eMessage$'

else

  s_id = selected("Strings")
  nfiles = Get number of strings
  for file from 1 to 'nfiles'
    select 's_id'
    filename$ = Get string... 'file'
    execute "'script$'" "'directory$''filename$'" 'args$'
    endfor

  select 's_id'
  Remove

  endif
