#	Since Praatcon does *not* assign default values to missing arguments,
#	take the default values from a form/endform construct in a Praat-script
#	and print a praatcon-command-with-arguments to have the script executed.
#
#	J J A Pacilly,  5-dec-2006, for public use
#	J J A Pacilly, 22-may-2007, allow scripts without form/endfrom construct

/form /	{nArg = 0; next}

/real / || /positive / || /integer /  || /natural / {
	if (NF == 3) {Arg[++nArg] = $3; next} else {exit}
	}

/word / {
	if (NF >= 3) {Arg[++nArg] = $3; next} else {exit}
	}

/sentence / || /text / {
	if (NF >= 3) {Arg[++nArg] = "\"" substr($0, index($0, $3)) "\""; next} else {exit}
	}

/boolean / {
	if (NF == 3 && ($3 == 1 || $3 = "yes" || $3 == "Yes" || $3 == "YES")) {
	  Arg[++nArg] = 1
	  }
	else {
	  Arg[++nArg] = 0
	  }
	next
	}

/choice / || /optionmenu / {
	nChoice = 0
	if (NF == 3) {nChoiceDef = $3; next} else {exit}
	}

/button / || /option / {
	if (++nChoice == nChoiceDef) {
	  Arg[++nArg] = "\"" substr($0, index($0, $2)) "\""
	  }
	next
	}

/endform/ {
	printf "praatcon \"%s\" ", FILENAME
	for (n=1; n<= nArg; n++) {printf "%s ", Arg[n]}
	printf "\n"
	done = 1
	exit
	}

END {	if (!done) {printf "praatcon \"%s\"\n", FILENAME}}
